Answers to: Merge Sort Tree - Tutorialhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial<p><strong>Prerequisites</strong> : Segment Trees</p>
<p><strong>Target Problem</strong> : Given an array of N elements and you have to answer Q queries of the form L R K , To Count the numbers smaller than K in range L to R.</p>
<p><strong>Key Idea</strong> : The key idea is to build a Segment Tree with a vector at every node and the vector contains all the elements of the subrange in a sorted order . And if you observe this segment tree structure this is some what similar to the tree formed during the merge sort algorithm ( Yes , thats why they are called Merge Sort Trees ) .</p>
<p><strong>Building the tree :</strong></p>
<pre><code>vector<int>tree[5*N];
int A[N];
Void build_tree( int cur , int l , int r )
{
if( l==r )
{
tree[cur].push_back( a[ l ] );
return ;
}
int mid = l+(r-l)/2;
build_tree(2*cur+1 , l , mid ); // Build left tree
build_tree(2*cur+2 , mid+1 , r ); // Build right tree
tree[cur] = merge( tree[2*cur+1] , tree[2*cur+2] ); //Merging the two sorted arrays
}
</code></pre>
<p><strong>Querying the tree :</strong></p>
<pre><code>int query( int cur, int l, int r, int x, int y, int k)
{
if( r < x || l > y )
{
return 0; //out of range
}
if( x<=l && r<=y )
{
//Binary search over the current sorted vector to find elements smaller than K
Return upper_bound(tree[cur].begin(),tree[cur].end(),K)-tree[cur].begin();
}
int mid=l+(r-l)/2;
return query(2*cur+1,l,mid,x,y,k)+query(2*cur+2,mid+1,r,x,y,k);
}
</code></pre>
<p><strong>Build function Analysis</strong> : Build a merge sort tree takes O(NlogN) time which is same as Merge Sort Algorithm . It will take O(NlogN) memory because each number Ai will be present in at most LogN vectors (Height of the tree ) . </p>
<p><strong>Query function Analysis</strong> : A range L to R can divided into at most Log(N) parts, where we will perform binary search on each part . So this gives us complexity of O(LogN * LogN) per query .</p>
<p><strong>Handling Point Updates</strong> : The only reason that we cant handle updates on MST in this code is because its merge function takes too much time, so even if theres a point update it will lead to O(N). So the major issue is of vectors and rearranging them on updations, but why do we need vectors ? Just to find the elements smaller than K in that complete vector, right ? Lets forget about vectors and keep <a href="http://codeforces.com/blog/entry/11080">policy based data structure</a> at each node which handles three queries (insertion , deletion and elements smaller than K in the set) in O(LogN) time . So now no need to rearrange vectors and we can use insertion - deletion to handle point queries . This is just an idea , we can discuss this in comments again if anyone has a doubt .</p>
<p><strong>Bonus</strong> :
How to use this to solve the query of type Kth smallest number in range L to R ? So we can binary search over the solution and find the value which has exactly K numbers smaller than it in the given range . Complexity : O(LogN * LogN * LogAi ) per query . </p>
<p><strong>Why to use MST:</strong> Apart from the code simplicity, they answer queries online . We could have used some offline algorithms like MOs or even Segment tree but come on, Online Querying is great because it can be used in Dp Optimisations and stuff like that . Peace Out .</p>enTue, 11 Sep 2018 17:32:22 +0530Answer by jamesspadehttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/135148<p>possibly. All things considered, the main vital things - after comprehend fragment tree in its pointer usage are: - In each refresh, at most logN hub change -<a href="http://www.fsdsolutions.com/">software companies in united states</a>, In each refresh, make another adaptation of all hubs changed</p>jamesspadeTue, 11 Sep 2018 17:32:22 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/135148Answer by parth_patel15https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/120995<p>Can anyone help me in the spoj problem <a href="http://www.spoj.com/problems/MKTHNUM/">MKTHNUM</a> and tell me why I am getting wrong answer? <a href="https://ideone.com/sqKKVQ">MY SOLUTION</a></p>parth_patel15Sun, 07 Jan 2018 18:33:30 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/120995Comment by lukecavabarret on lukecavabarret's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#105947<p>maybe. After all, the only important things -after understand segment tree in its pointer implementation- are:
-In each update, at most logN node change
-In each update, create a new version of all nodes changed</p>lukecavabarretWed, 19 Jul 2017 22:20:45 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#105947Comment by arunnsit on lukecavabarret's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#104443<p>yeah, Persistent Segment Tree can solve such problems but do you think its as easy to explain and understand as this?</p>arunnsitThu, 06 Jul 2017 13:13:21 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#104443Answer by lukecavabarrethttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/103883<p>We can achieve much better. First, we compress the array in order to contain only values in range [0,N). We keep a table to associate a compressed value to the original one in O(1) and associate a normal value to his lower_bound in compressed range in O(logN). This take us so far NlogN. Then we build a Persistent Segment Tree, where for every time i we have stored the frequencies of each value in the array with index smaller or equal to i, and every node store the sum of the two sons. Overall is NlogN preprocessing.
Every time we want to know how many integers there are in range [l,r] smaller than k, we do as follows:</p>
<ul>
<li>first we replace k with the compressed value of the greater original value smaller than k. //logN</li>
<li>We query the Persistent Segmentent Tree in the interval [0,k], assuming that the value written in each node is the one of the tree(r) - tree(l-1).</li>
</ul>
<p>In the end we use NlogN space and time complexity for preprocessing, and each query take logN. But we can do a lot of amazing other stuff, for example, being asked about the k-th smallest value in range [l,r], and answer in logN as well.</p>lukecavabarretSun, 02 Jul 2017 17:17:18 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/103883Comment by manjrekarom29 on manjrekarom29's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#102964<p>Oh yes! I got confused. Thanks</p>manjrekarom29Fri, 23 Jun 2017 08:24:37 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#102964Comment by arunnsit on manjrekarom29's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#102909<p>Why do you think log2(10^5) * 10^5 vectors are required? vectors should be equal to number N+N/2+N/4+N/8....(i.e number of nodes in segtree) Which is 2<em>N but we require a number which is multiple of 2 and greater than 2</em>N. So to be on safe side we usually take 4*N nodes in segtree.</p>arunnsitThu, 22 Jun 2017 18:15:29 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#102909Answer by manjrekarom29https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/102770<p>For elements of size 10^5 ill have to define vector<int> tree[log2(10^5) * 10^5] right? </p>
<p>It's giving me runtime error for such big chunk of memory in c++.</p>
<p>Please clarify! Thanks!</p>manjrekarom29Wed, 21 Jun 2017 08:20:52 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/102770Comment by mayank12559 on likecs's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101938<p><a href="/users/93307/likecs">@likecs</a> I have written the code in c++. On submission I am getting Wrong Answer now. Can you please help me once again?
Link to my code : <a href="http://ideone.com/qC2tVy">http://ideone.com/qC2tVy</a></p>mayank12559Thu, 15 Jun 2017 16:54:33 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101938Comment by mayank12559 on likecs's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101897<p>Thanks for the reply. I will try to write the same in c++. Java solution should also get accepted though, as c++ solutions are getting accepted with same complexity. There should not be any discrimination among languages. mayank12559Thu, 15 Jun 2017 08:22:47 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101897Comment by likecs on likecs's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101884<p><a href="/users/35317/mayank12559">@mayank12559</a>, I tried to optimise your solution by making the binary serach iterative as well, but no sucess. May be the time limits of the problem are strict for java for passing with O(log^2n) approach. Also, only 4 solutions in java for this problem till date. May be you can try with C++.</p>likecsThu, 15 Jun 2017 00:39:42 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101884Comment by mayank12559 on likecs's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101874<p><a href="/users/93307/likecs">@likecs</a> I have written the exactly same solution as you did, but in java. I am getting TLE. Can you please help me?
Note : I am using the fast I/O also.
Link to my code : <a href="http://ideone.com/pHN7Z2">http://ideone.com/pHN7Z2</a></p>mayank12559Wed, 14 Jun 2017 22:30:05 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#101874Comment by sinbycos on sinbycos's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#100894<p>But that's only better if ai < N, right?</p>sinbycosFri, 09 Jun 2017 08:25:10 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#100894Comment by arunnsit on s1_73's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#100381<p>i think you aren't clear about binary search, we will binary search for the smallest number that satisfies the above condition i.e. for query(L,R,X), and X=R-L+1.find out the smallest number which gives number of numbers <= Ai to be X. Theres no need to track its presence in array.</p>arunnsitSat, 03 Jun 2017 14:07:01 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#100381Answer by s1_73https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/99897<p>For the bonus part, consider a <em>query(L,R,X)</em>, and <em>X=R-L+1</em>, which means that you need to find out the maximum number from the range <em>L</em> to <em>R</em>. According to your solution, we can binary search on <em>Ai</em>, and find out which number gives <em>number of numbers <= Ai</em> to be X. But how will you keep a track of <em>Ai</em>s which are present in the range <em>[L,R]</em> of the original array <em>A</em>? This is needed because for the case where you need to find the maximum in a range <em>[L,R]</em>, any number <em>Y</em> lying between the maximum number from <em>[L,R]</em> and the next maximum in the array <em>A</em> will also yield <em>X</em> as the answer to the <em>query(L,R,Y)</em>. </p>s1_73Wed, 31 May 2017 19:54:25 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/99897Comment by shraeyas on kateylizzard's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97810<p>A great way to spam. Indeed :)</p>shraeyasMon, 08 May 2017 21:28:15 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97810Comment by arunnsit on rajarshi_basu's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97739<p>i have already mentioned about point updates. is there anything that you didnt understand?</p>arunnsitSun, 07 May 2017 03:58:21 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97739Comment by arunnsit on sinbycos's answerhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97738<p>yes, you are correct too. thats one way to see it. if you binary search over the array it will come out to be O(q<em>log^3 n). but if you binary search over the a[i] value then it comes out to be O(q</em>log^2 n*log ai).</p>arunnsitSun, 07 May 2017 03:56:37 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial#97738Answer by rajarshi_basuhttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/97000<p>how can you handle updates here..?</p>rajarshi_basuFri, 28 Apr 2017 18:13:47 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/97000Answer by sinbycoshttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/96989<p>I'm confused.. Why would the complexity have a factor of logAi in the "Bonus" part. I can only think of a O(q*log^3 n) solution. Binary search over the array and find the value that has k-1 smaller numbers in O(log^2 n).</p>
<p>Also, would appreciate if you could upvote me. Need karma points :P
Thanks!</p>sinbycosFri, 28 Apr 2017 08:35:09 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/96989Answer by likecshttps://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/94482<p>You can do Kth smallest number query in range L to R, in $O(n * {\log}^{2}n)$ by building the merge sort tree on indices instead of the values. This solution doesn't depend on the values of $A[i]$, however large they may be.</p>
<p>For implementation details, one may refer to <a href="http://ideone.com/T4gxB9">this code</a> for <a href="http://www.spoj.com/problems/MKTHNUM/">MKTHNUM</a> problem on Spoj.</p>likecsTue, 28 Mar 2017 00:33:44 +0530https://discuss.codechef.com/questions/94448/merge-sort-tree-tutorial/94482